<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOf_xsd_failed ArrayType
 * @subpackage Arrays
 */
class ArrayOf_xsd_failed extends AbstractStructArrayBase
{
    /**
     * The failed
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $failed;
    /**
     * Constructor method for ArrayOf_xsd_failed
     * @uses ArrayOf_xsd_failed::setFailed()
     * @param string[] $failed
     */
    public function __construct(array $failed = array())
    {
        $this
            ->setFailed($failed);
    }
    /**
     * Get failed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getFailed()
    {
        return isset($this->failed) ? $this->failed : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFailed method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFailed method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFailedForArrayConstraintsFromSetFailed(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOf_xsd_failedFailedItem) {
            // validation for constraint: itemType
            if (!is_string($arrayOf_xsd_failedFailedItem)) {
                $invalidValues[] = is_object($arrayOf_xsd_failedFailedItem) ? get_class($arrayOf_xsd_failedFailedItem) : sprintf('%s(%s)', gettype($arrayOf_xsd_failedFailedItem), var_export($arrayOf_xsd_failedFailedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The failed property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set failed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $failed
     * @return \ArrayType\ArrayOf_xsd_failed
     */
    public function setFailed(array $failed = array())
    {
        // validation for constraint: array
        if ('' !== ($failedArrayErrorMessage = self::validateFailedForArrayConstraintsFromSetFailed($failed))) {
            throw new \InvalidArgumentException($failedArrayErrorMessage, __LINE__);
        }
        if (is_null($failed) || (is_array($failed) && empty($failed))) {
            unset($this->failed);
        } else {
            $this->failed = $failed;
        }
        return $this;
    }
    /**
     * Add item to failed value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOf_xsd_failed
     */
    public function addToFailed($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The failed property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->failed[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string failed
     */
    public function getAttributeName()
    {
        return 'failed';
    }
}
